/* $Id: misclib.c,v 1.1 1993/10/25 22:35:42 cwikla Exp $ */

/* $XConsortium: xwud.c,v 1.48 91/07/25 18:02:05 rws Exp $ */
/* Copyright 1985, 1986, 1988 Massachusetts Institute of Technology */

/*
Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in advertising or
publicity pertaining to distribution of the software without specific,
written prior permission.  M.I.T. makes no representations about the
suitability of this software for any purpose.  It is provided "as is"
without express or implied warranty.
*/

/* xwud - marginally useful raster image undumper */

/*
**
** Copyright (c) 1993 by Wolfram Research, Inc.  All Rights Reserved.
** 
** WOLFRAM RESEARCH, INC. ("WRI") DOES NOT WARRANT THAT THE SOFTWARE CONTAINED IN
** THIS FILE IS FREE FROM BUGS AND OMISSIONS; THE SOFTWARE IS PROVIDED AS IS.
** WRI MAKES NO REPRESENTATIONS, EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE,
** INCLUDING WITHOUT LIMITATIONS ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR
** FITNESS FOR A PARTICULAR PURPOSE, ALL OF WHICH IS EXPRESSLY DISCLAIMED.  WRI
** DOES NOT WARRANT THAT THE SOFTWARE WILL MEET YOUR REQUIREMENTS OR THAT ITS
** OPERATION WILL BE UNINTERRUPTED OR ERROR FREE.
** 
** WRI DOES NOT WARRANT THAT THE SOFTWARE CONTAINED IN THIS FILE DOES NOT
** INFRINGE UPON THE INTELLECTUAL PROPERTY RIGHTS OF ANY THIRD PARTIES.
** 
** USE OF THE SOFTWARE CONTAINED IN THIS FILE IS ENTIRELY AT YOUR OWN RISK.
** 
** To the extent that it is authorized to do so, Wolfram Research grants the
** recipient of this software permission to use the software for his/her own
** personal purposes subject the user's acceptance of the terms stated above
** and the user's inclusion of Wolfram Reseach's copyright notice and disclaimers
** in any reproduction and/or derivative of this file.  
** 
**
**
**	John L. Cwikla
**	cwikla@wri.com
** 	Wolfram Research, Inc
*/

#include "misclib.h"


void SwapShort (register char *_bp, register unsigned int _n)
{
  register char c;
  register char *ep = _bp + _n;

  while (_bp < ep)
  {
    c = *_bp;
    *_bp = *(_bp + 1);
    _bp++;
    *_bp++ = c;
  }
}

void SwapLong (register char *_bp, register unsigned int _n)
{
  register char c;
  register char *ep = _bp + _n;
  register char *sp;

  while (_bp < ep)
  {
    sp = _bp + 3;
    c = *sp;
    *sp = *_bp;
    *_bp++ = c;
    sp = _bp + 1;
    c = *sp;
    *sp = *_bp;
    *_bp++ = c;
    _bp += 2;
  }
}

void SetBit(unsigned char *_data, int _x, int _y, int _width)
{
  unsigned char *byte;
  int shift, offset;
  unsigned char set;

  offset = (_y * _width + _x)/ 8;
  shift = _x % 8;

  byte = _data + offset;

  set = (unsigned char)((1 << shift) & 0xFF);

  *byte |= set;
}

int GetBit(unsigned char *_data, int _x, int _y, int _width)
{
  unsigned char *byte;
  int shift, offset;
  unsigned char set;

  offset = (_y * _width + _x) / 8;
  shift = _x % 8;

  byte = _data + offset;

  set = (unsigned char)((1 << shift) & 0xFF);

  return (int)(set & (*byte));
}

